VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1305
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3960
   LinkTopic       =   "Form1"
   ScaleHeight     =   1305
   ScaleWidth      =   3960
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picSample 
      Height          =   615
      Left            =   3120
      ScaleHeight     =   555
      ScaleWidth      =   675
      TabIndex        =   8
      Top             =   120
      Width           =   735
   End
   Begin VB.TextBox txtS 
      Height          =   285
      Left            =   2280
      TabIndex        =   7
      Top             =   480
      Width           =   735
   End
   Begin VB.TextBox txtL 
      Height          =   285
      Left            =   1440
      TabIndex        =   6
      Top             =   480
      Width           =   735
   End
   Begin VB.TextBox txtH 
      Height          =   285
      Left            =   600
      TabIndex        =   5
      Top             =   480
      Width           =   735
   End
   Begin VB.TextBox txtB 
      Height          =   285
      Left            =   2280
      TabIndex        =   4
      Top             =   120
      Width           =   735
   End
   Begin VB.TextBox txtG 
      Height          =   285
      Left            =   1440
      TabIndex        =   3
      Top             =   120
      Width           =   735
   End
   Begin VB.TextBox txtR 
      Height          =   285
      Left            =   600
      TabIndex        =   1
      Top             =   120
      Width           =   735
   End
   Begin VB.Label Label2 
      Caption         =   "Note: These RGB values should be between 0 and 1."
      Height          =   495
      Left            =   600
      TabIndex        =   9
      Top             =   840
      Width           =   2535
   End
   Begin VB.Label Label1 
      Caption         =   "HLS"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   2
      Top             =   480
      Width           =   375
   End
   Begin VB.Label Label1 
      Caption         =   "RGB"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   375
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_IgnoreEvents As Boolean
Private Function QqhToRgb(ByVal q1 As Double, ByVal q2 As Double, ByVal hue As Double) As Double
    If hue > 360 Then
        hue = hue - 360
    ElseIf hue < 0 Then
        hue = hue + 360
    End If
    If hue < 60 Then
        QqhToRgb = q1 + (q2 - q1) * hue / 60
    ElseIf hue < 180 Then
        QqhToRgb = q2
    ElseIf hue < 240 Then
        QqhToRgb = q1 + (q2 - q1) * (240 - hue) / 60
    Else
        QqhToRgb = q1
    End If
End Function

' Convert an RGB value into an HLS value.
Private Sub RgbToHls(ByVal R As Double, ByVal G As Double, ByVal B As Double, ByRef H As Double, ByRef L As Double, ByRef S As Double)
Dim max As Double
Dim min As Double
Dim diff As Double
Dim r_dist As Double
Dim g_dist As Double
Dim b_dist As Double

    ' Get the maximum and minimum RGB components.
    max = R
    If max < G Then max = G
    If max < B Then max = B

    min = R
    If min > G Then min = G
    If min > B Then min = B

    diff = max - min
    L = (max + min) / 2
    If Abs(diff) < 0.00001 Then
        S = 0
        H = 0   ' H is really undefined.
    Else
        If L <= 0.5 Then
            S = diff / (max + min)
        Else
            S = diff / (2 - max - min)
        End If

        r_dist = (max - R) / diff
        g_dist = (max - G) / diff
        b_dist = (max - B) / diff

        If R = max Then
            H = b_dist - g_dist
        ElseIf G = max Then
            H = 2 + r_dist - b_dist
        Else
            H = 4 + g_dist - r_dist
        End If

        H = H * 60
        If H < 0 Then H = H + 360
    End If
End Sub
' Convert an HLS value into an RGB value.
Private Sub HlsToRgb(ByVal H As Double, ByVal L As Double, ByVal S As Double, ByRef R As Double, ByRef G As Double, ByRef B As Double)
Dim p1 As Double
Dim p2 As Double

    If L <= 0.5 Then
        p2 = L * (1 + S)
    Else
        p2 = L + S - L * S
    End If
    p1 = 2 * L - p2
    If S = 0 Then
        R = L
        G = L
        B = L
    Else
        R = QqhToRgb(p1, p2, H + 120)
        G = QqhToRgb(p1, p2, H)
        B = QqhToRgb(p1, p2, H - 120)
    End If
End Sub

' Display RGB from HLS.
Private Sub DisplayRGB()
Dim R As Double
Dim G As Double
Dim B As Double

    If m_IgnoreEvents Then Exit Sub

    m_IgnoreEvents = True
    On Error Resume Next
    HlsToRgb txtH.Text, txtL.Text, txtS.Text, R, G, B
    txtR.Text = Format$(R)
    txtG.Text = Format$(G)
    txtB.Text = Format$(B)
    m_IgnoreEvents = False

    picSample.BackColor = RGB(255 * R, 255 * G, 255 * B)
End Sub
' Display HLS from RGB.
Private Sub DisplayHLS()
Dim H As Double
Dim L As Double
Dim S As Double

    If m_IgnoreEvents Then Exit Sub

    m_IgnoreEvents = True
    On Error Resume Next
    RgbToHls txtR.Text, txtG.Text, txtB.Text, H, L, S
    txtH.Text = Format$(H)
    txtL.Text = Format$(L)
    txtS.Text = Format$(S)
    m_IgnoreEvents = False

    picSample.BackColor = RGB(255 * txtR.Text, 255 * txtG.Text, 255 * txtB.Text)
End Sub
Private Sub txtB_Change()
    DisplayHLS
End Sub

Private Sub txtG_Change()
    DisplayHLS
End Sub

Private Sub txtH_Change()
    DisplayRGB
End Sub

Private Sub txtL_Change()
    DisplayRGB
End Sub


Private Sub txtR_Change()
    DisplayHLS
End Sub


Private Sub txtS_Change()
    DisplayRGB
End Sub

